import { ControlValueAccessor, NgControl } from '@angular/forms';
import { Injector } from '@angular/core';
export declare abstract class ValueAccessorBase<T> implements ControlValueAccessor {
    private theInjector;
    private innerValue;
    private changed;
    private touched;
    disabled: boolean;
    private control;
    protected readonly formControl: NgControl;
    value: T;
    constructor(theInjector: Injector);
    writeValue(value: T): void;
    registerOnChange(fn: (value: T) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(disabled: boolean): void;
    touch(): void;
}
